(*@PROPERTIES_EX@
TYPE: POU
LOCALE: 0
IEC_LANGUAGE: ST
PLC_TYPE: independent
PROC_TYPE: independent
GROUP: ENGINEERING.SENSOR
*)
(*@KEY@:DESCRIPTION*)
version 1.5	10. mar. 2009
programmer 	hugo
tested by	tobias

this function returs the temperature for a silicon sensor for a range from -60..+180 C
for example KTY10 RS at TS normally 25 C

(*@KEY@:END_DESCRIPTION*)
FUNCTION TEMP_SI:REAL

(*Group:Default*)


VAR_INPUT
	RES :	REAL;
	RS :	REAL;
	TS :	REAL;
END_VAR


(*@KEY@: WORKSHEET
NAME: TEMP_SI
IEC_LANGUAGE: ST
*)
TEMP_SI := (-7.64E-3 + SQRT(Res/RS* 6.64E-5 - 0.803E-5)) * 30120.48193 + TS;



(* revision history

hm 24.1.2007		rev 1.1
	the function would only work for TS = 25, now it works for other values of ts.

hm 10.9.2007		rev 1.2
	changed the function to use successive approcimation to avoid an error generated by a sqrt from a negative result.
	changed accuracy to 0.02 degrees to shorten execution time

hm 17. 12 2007	rev 1.3
	improovements for better performance

hm	6. jan 2008	rev 1.4
	further performance improvement

hm	10. mar. 2009	rev 1.5
	removed nested comments

*)
(*@KEY@: END_WORKSHEET *)
END_FUNCTION
